:- use_module(library(clpfd)).
 

donald(Vars,Cars) :-
    Cars = [C1,C2,C3,C4,C5],
    Cars ins 0..1,
    Vars = [D,O,N,A,L,G,E,R,B,T],
    Vars ins 0..9,
    all_different(Vars),
    O + E + C4   #= O + 10*C5,
    2*A + C2 #= E + 10*C3,
    2*L + C1 #= R + 10*C2,
    2*D      #= T + 10*C1,
    D + G + C5 #= R,
    N + R + C3 #= B + 10*C4.
  
   

solve_donald(Vars,Cars) :-
    Cars = [C1,C2,C3,C4,C5],
    Vars = [D,O,N,A,L,G,E,R,B,T],
    donald([D,O,N,A,L,G,E,R,B,T],[C1,C2,C3,C4,C5]),
    label(Vars),
    label(Cars).

donald_sum(Vars) :-
    Vars = [D,O,N,A,L,G,E,R,B,T],
    Vars ins 0..9,
    all_different(Vars),
   100000*D + 10000*O + 1000*N + 100*A + 10*L + D
+  100000*G + 10000*E + 1000*R + 100*A + 10*L + D
#=
   100000*R + 10000*O + 1000*B + 100*E + 10*R + T.

solve_donald_sum(V) :-
   V =  [D,O,N,A,L,G,E,R,B,T],donald_sum([D,O,N,A,L,G,E,R,B,T]),label(V).
    




send6(Vars,Cars) :-
    Cars = [C1,C2,C3,C4],
    Cars ins 0..1,
    Vars = [S,E,N,D,M,O,R,Y],
    Vars ins 0..9,
    all_different(Vars),
    S #\= 0,
    M #\= 0,
    M #= C4,
    S + M + C3 #= 10*C4 + O,
    E + O + C2 #= 10*C3 + N,
    N + R + C1 #= 10*C2 + E, 
    D + E      #= 10*C1 + Y.

    
solve6(Vars,Cars):- Vars=[S,E,N,D,M,O,R,Y],Cars=[C1,C2,C3,C4], 
                 send5([S,E,N,D,M,O,R,Y],[C1,C2,C3,C4]),label(Vars),label(Cars).  
    

sendmoremoney(Vars) :-
    Vars = [S,E,N,D,M,O,R,Y],
    Vars ins 0..9,
    S #\= 0,
    M #\= 0,
    all_different(Vars),
                 1000*S + 100*E + 10*N + D
    +            1000*M + 100*O + 10*R + E
    #= 10000*M + 1000*O + 100*N + 10*E + Y.

solve(Vars):- Vars=[S,E,N,D,M,O,R,Y],sendmoremoney([S,E,N,D,M,O,R,Y]),label(Vars).



send5(Vars,Cars) :-
    Cars = [C1,C2,C3,C4],
    Cars ins 0..1,
    Vars = [S,E,N,D,M,O,R,Y],
    Vars ins 0..9,
    all_different(Vars),
    S #\= 0,
    M #\= 0,
    M #= C4,
    D + E      #= 10*C1 + Y,
    N + R + C1 #= 10*C2 + E, 
    E + O + C2 #= 10*C3 + N,
    S + M + C3 #= 10*C4 + O.
    
solve5(Vars,Cars):- Vars=[S,E,N,D,M,O,R,Y],Cars=[C1,C2,C3,C4], 
                 send5([S,E,N,D,M,O,R,Y],[C1,C2,C3,C4]),label(Vars),label(Cars).

puzzle([S,E,N,D] + [M,O,R,E] = [M,O,N,E,Y]) :-
        Vars = [S,E,N,D,M,O,R,Y],
        Vars ins 0..9,
        all_different(Vars),
                  S*1000 + E*100 + N*10 + D +
                  M*1000 + O*100 + R*10 + E #=
        M*10000 + O*1000 + N*100 + E*10 + Y,
        M #\= 0, S #\= 0.


go3(Send,More,Money):- puzzle(Send+More=Money),label(Send).
